import * as tslib_1 from "tslib";
import * as React from "react";
import Register from "@vericus/slate-kit-utils-register-helpers";
export default function createRenderMark(options) {
    var marks = options.marks;
    var marksRenderer = Object.entries(marks).reduce(function (renderers, _a) {
        var _b;
        var _c = tslib_1.__read(_a, 2), markName = _c[0], _markType = _c[1];
        return tslib_1.__assign({}, renderers, (_b = {}, _b[markName] = function (props) {
            var attributes = props.attributes, children = props.children, className = props.className;
            return (<span {...attributes} className={className}>
              {children}
            </span>);
        }, _b));
    }, {});
    return Register({ marksRenderer: marksRenderer });
}
//# sourceMappingURL=renderMark.jsx.map